<?php



class Tx_Powermailpdf_Pdf extends Tx_Powermail_Controller_FormsController {
	
	
	/**
	 *
	 * @param array $field
	 * @return path to pdf
	 * This function is used when pdftk is NOT installed on system
	 * Remember: No chockboxes possible
	 */
	function generate_pdf($field){
		require 'fpdm.php';
		//ToDo Map Fields from $field to array;
		//Normal Fields
		$fieldMap= $GLOBALS['TSFE']->tmpl->setup['plugin.']['tx_powermailpdf.']['settings.']['fieldMap.'];
		
		foreach ($fieldMap as $key => $value) {
			$fdf_data_strings[$key]  = $field[$value];
		}
		
		$pdf_original = t3lib_extMgm::extPath(strtolower($this->extensionName)).$GLOBALS['TSFE']->tmpl->setup['plugin.']['tx_powermailpdf.']['settings.']['sourcefile'];
		if (isset($pdf_original)){
			// Name of file to be downloaded
			$pdf_filename = PATH_site.'uploads/powermailpdf/'.md5($field['e_mail']).'.pdf';
			$pdf = new FPDM($pdf_original);
			$pdf->Load($fdf_data_strings, true); // second parameter: false if field values are in ISO-8859-1, true if UTF-8
			$pdf->Merge();
			$pdf->Output($pdf_filename, "");
		}else{
			//@ToDO some Error
		}
		
		return $pdf_filename;
		
	}
	
	/**
	 * 
	 * @param array $field
	 * @return path to pdf
	 * This function is used when pdftk is installed on system
	 */
	
	function generate_pdf_pdftk($field){
		require 'pdftk-php.php';
		
		// Initiate the class
		$pdfmaker = new pdftk_php;
		
		// Define variables for all the data fields in the PDF form. You need to assign a column in the database to each field that you'll be using in the PDF.
		// Example:
		// $pdf_column = $data['column'];
		
		// You can also format the MySQL data how you want here. One common example is formatting a date saved in the database. For example:
		// $pdf_date = date("l, F j, Y, g:i a", strtotime($data['date']));
		

		
		// $fdf_data_strings associates the names of the PDF form fields to the PHP variables you just set above. In order to work correctly the PDF form field name has to be exact. PDFs made in Acrobat generally have simpler names - just the name you assigned to the field. PDFs made in LiveCycle Designer nest their forms in other random page elements, creating a long and hairy field name. You can use pdftk to discover the real names of your PDF form fields: run "pdftk form.pdf dump_data_fields > form-fields.txt" to generate a report.
		
		// Example of field names from a PDF created in LiveCycle:
		// $fdf_data_strings= array('form1[0].#subform[0].#area[0].LastName[0]' => $pdf_lastname,  'form1[0].#subform[0].#area[0].FirstName[0]' => $pdf_firstname, 'form1[0].#subform[0].#area[0].EMail[0]' => $pdf_email, );
		#$fdf_data_strings= array('E-Mail' => $pdf_firstname,  'Fax' => $pdf_lastname);
		$fdf_data_strings=$GLOBALS['TSFE']->tmpl->setup['plugin.']['tx_powermailpdf.']['settings.']['fieldMap.'];
		
		// See the documentation of pdftk-php.php for more explanation of these other variables.
		
		// Used for radio buttons and check boxes
		// Example: (For check boxes options are Yes and Off)
		// $pdf_checkbox1 = "Yes";
		// $pdf_checkbox2 = "Off";
		// $pdf_checkbox3 = "Yes";
		// $fdf_data_names = array('checkbox1' => $pdf_checkbox1,'checkbox2' => $pdf_checkbox2,'checkbox3' => $pdf_checkbox3,'checkbox4' => $pdf_checkbox4);
		$fdf_data_names = array(); // Leave empty if there are no radio buttons or check boxes
		$fdf_data_names = array('Einverst'.chr(228).'ndnis-Checkbox'    => 'Nein', 'Preis1'    => 'Nein', 'Preis2'    => 'Nein', 'Preis3' => 'Ja');
		
		$fields_hidden = array(); // Used to hide form fields
		
		$fields_readonly = array(); // Used to make fields read only - however, flattening the output with pdftk will in effect make every field read only. If you don't want a flattened pdf and still want some read only fields, use this variable and remove the flatten flag near line 70 in pdftk-php.php
		
		// Name of file to be downloaded
		$pdf_filename = "Test PDF for $pdf_firstname $pdf_lastname.pdf";
		
		// Name/location of original, empty PDF form
		$pdf_original = "source2.pdf";
		
		// Finally make the actual PDF file!
		$pdfmaker->make_pdf($fdf_data_strings, $fdf_data_names, $fields_hidden, $fields_readonly, $pdf_original, $pdf_filename);
		
		
	}
	
	/**
	 * @param string $uri the URI that will be put in the href attribute of the rendered link tag
	 * @param string $label
	 * @return string Rendered link
	 */
	
	public function render($uri, $label) {
	
		//get filelinkconf from typoscript setup plugin.tx_productdownloads.settings.filelink
		$filelinkconf = $GLOBALS['TSFE']->tmpl->setup['plugin.']['tx_powermailpdf.']['settings.']['filelink.'];
	
		//replace the link label with the param $label
		$filelinkconf['labelStdWrap.']['cObject'] = 'TEXT';
		$filelinkconf['labelStdWrap.']['cObject.']['value'] = $label;
	
		$output = $GLOBALS['TSFE']->cObj->filelink($uri,$filelinkconf);
	
		return $output;
	}
	
	function main($field,$form,$mail,$controller){
		
		$file=$this->generate_pdf($controller->div->getVariablesWithMarkers($field));
		
		//Generiet einen Link mit action: generate_pdf
		$label= Tx_Extbase_Utility_Localization::translate("download","powermailpdf");
		$link=$this->render($file, $label);
		
		$controller->view->assign('powermail_pdf', $link);
	
	}
	}
?>